/**
 * 
 */
package element;

/**
 * @author PaulWilliams
 *
 */
public abstract class AbstractElement {
	private String name;
	private int maxActivations;
	private boolean activated;
	private String onOccur;
	
	public AbstractElement(String name, int maxActivations,
							boolean activated, String onOccur){
		this.name=name;
		this.maxActivations=maxActivations;
		this.activated=activated;
		this.onOccur=onOccur;
	}

	public AbstractCompositeElement asAbstractCompositeElement() {
		return null;
	}
	
	public AnyElement asAnyElement() {
		return null;
	}
	
	public AllElement asAllElement() {
		return null;
	}
	
	public PerceptionElement asPerceptionElement() {
		return null;
	}
	
	public String writeToXml() {
		String xml = null;
		xml += "<"+name;
		if (maxActivations!=0)
			xml+= " maxActivations="+maxActivations;
		if (activated)
			xml+= " activated ="+activated;
		if (onOccur!=null)
			xml+= " onOccur="+onOccur;
		xml+="/>";
		return xml;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the maxActivations
	 */
	public int getMaxActivations() {
		return maxActivations;
	}

	/**
	 * @param maxActivations the maxActivations to set
	 */
	public void setMaxActivations(int maxActivations) {
		this.maxActivations = maxActivations;
	}

	/**
	 * @return the activated
	 */
	public boolean isActivated() {
		return activated;
	}

	/**
	 * @param activated the activated to set
	 */
	public void setActivated(boolean activated) {
		this.activated = activated;
	}

	/**
	 * @return the onOccur
	 */
	public String getOnOccur() {
		return onOccur;
	}

	/**
	 * @param onOccur the onOccur to set
	 */
	public void setOnOccur(String onOccur) {
		this.onOccur = onOccur;
	}

}
