package activity;

public abstract class AbstractActivity {

	private String type;
	private String name;
	private boolean repeat;
	private boolean minor;
	private String startOn;
	private String stopOn;
	private String onBegin;
	private String onEnd;
	private String onInterupt;
	private String activate;
	private String deactivate;
	
	public AbstractActivity(String type, String name, boolean repeat,
			boolean minor, String startOn, String stopOn, String onBegin,
			String onEnd, String onInterupt, String activate, String deactivate) {
		this.type = type;
		this.name = name;
		this.repeat = repeat;
		this.minor = minor;
		this.startOn = startOn;
		this.stopOn = stopOn;
		this.onBegin = onBegin;
		this.onEnd = onEnd;
		this.onInterupt = onInterupt;
		this.activate = activate;
		this.deactivate = deactivate;
	}

	public String writeXml() {
		String xml=null;
		xml+="<"+type+" name="+name;
		if (repeat)
			xml+=" repeat="+repeat;
		if (minor)
			xml+=" minor="+minor;
		if (startOn!=null)
			xml+=" startOn="+startOn;
		if (startOn!=null)
			xml+=" stopOn="+stopOn;
		if (onBegin!=null)
			xml+=" onBegin="+onBegin;
		if (onEnd!=null)
			xml+=" onEnd="+onEnd;
		if (onInterupt!=null)
			xml+=" onInterupt="+onInterupt;
		if (activate!=null)
			xml+=" activate="+activate;
		if (deactivate!=null)
			xml+=" deactivate="+deactivate;
		xml+=">";
		return xml;
	}
	public AbstractCompositeActivity asCompositActivity() {
		return null;
	}
	
	public ActionActivity asActionActivity(){
		return null;
	}
	
	public TaskActivity asTaskActivity() {
		return null;
	}
	
	public SelectedActivity asSelectedActivity(){
		return null;
	}
	
	public SequentialActivity asSequentialActivity() {
		return null;
	}
	
	public ParallelActivity asParallelActivity(){
		return null;
	}

	/**
	 * @return the type
	 */
	public String getType() {
		return type;
	}

	/**
	 * @param type the type to set
	 */
	public void setType(String type) {
		this.type = type;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the repeat
	 */
	public boolean isRepeat() {
		return repeat;
	}

	/**
	 * @param repeat the repeat to set
	 */
	public void setRepeat(boolean repeat) {
		this.repeat = repeat;
	}

	/**
	 * @return the minor
	 */
	public boolean isMinor() {
		return minor;
	}

	/**
	 * @param minor the minor to set
	 */
	public void setMinor(boolean minor) {
		this.minor = minor;
	}

	/**
	 * @return the startOn
	 */
	public String getStartOn() {
		return startOn;
	}

	/**
	 * @param startOn the startOn to set
	 */
	public void setStartOn(String startOn) {
		this.startOn = startOn;
	}

	/**
	 * @return the stopOn
	 */
	public String getStopOn() {
		return stopOn;
	}

	/**
	 * @param stopOn the stopOn to set
	 */
	public void setStopOn(String stopOn) {
		this.stopOn = stopOn;
	}

	/**
	 * @return the onBegin
	 */
	public String getOnBegin() {
		return onBegin;
	}

	/**
	 * @param onBegin the onBegin to set
	 */
	public void setOnBegin(String onBegin) {
		this.onBegin = onBegin;
	}

	/**
	 * @return the onEnd
	 */
	public String getOnEnd() {
		return onEnd;
	}

	/**
	 * @param onEnd the onEnd to set
	 */
	public void setOnEnd(String onEnd) {
		this.onEnd = onEnd;
	}

	/**
	 * @return the onInterupt
	 */
	public String getOnInterupt() {
		return onInterupt;
	}

	/**
	 * @param onInterupt the onInterupt to set
	 */
	public void setOnInterupt(String onInterupt) {
		this.onInterupt = onInterupt;
	}

	/**
	 * @return the activate
	 */
	public String getActivate() {
		return activate;
	}

	/**
	 * @param activate the activate to set
	 */
	public void setActivate(String activate) {
		this.activate = activate;
	}

	/**
	 * @return the deactivate
	 */
	public String getDeactivate() {
		return deactivate;
	}

	/**
	 * @param deactivate the deactivate to set
	 */
	public void setDeactivate(String deactivate) {
		this.deactivate = deactivate;
	}
	
	
}
