/**
 * 
 */
package element;

/**
 * @author PaulWilliams
 *
 */
public class AllElement extends AbstractCompositeElement {

	private boolean ordered;
	

	/**
	 * @param name
	 * @param maxActivations
	 * @param activated
	 * @param onOccur
	 */
	public AllElement(String name, int maxActivations, boolean activated,
			String onOccur, boolean ordered) {
		super(name, maxActivations, activated, onOccur);
		this.ordered=ordered;
	}

	public AllElement asAllElement(){
		return this;
	}
	public String writeToXml() {
		String xml=null;
		xml = writeToXml();
		if (ordered){
			xml =xml.substring(0, xml.length()-2);
			xml+=" ordered="+ordered+">";
		}
		return xml;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	/**
	 * @return the ordered
	 */
	public boolean isOrdered() {
		return ordered;
	}

	/**
	 * @param ordered the ordered to set
	 */
	public void setOrdered(boolean ordered) {
		this.ordered = ordered;
	}
}
